"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateSetupCodeSync = exports.generateSetupCode = void 0;
var tslib_1 = require("tslib");
var crypto_1 = tslib_1.__importDefault(require("crypto"));
var invalid = [
    "000-00-000",
    "111-11-111",
    "222-22-222",
    "333-33-333",
    "444-44-444",
    "555-55-555",
    "666-66-666",
    "777-77-777",
    "888-88-888",
    "999-99-999",
    "123-45-678",
    "876-54-321",
];
function toString(buffer) {
    return ("000" + buffer.readUInt16LE(0)).substr(-3) + "-" +
        ("00" + buffer.readUInt16LE(2)).substr(-2) + "-" +
        ("000" + buffer.readUInt16LE(4)).substr(-3);
}
function generateSetupCode(callback) {
    if (!callback) {
        return new Promise(function (rs, rj) { return generateSetupCode(function (err, result) { return err ? rj(err) : rs(result); }); });
    }
    crypto_1.default.randomBytes(6, function (err, buffer) {
        if (err) {
            return callback(err);
        }
        var setupCode = toString(buffer);
        if (!invalid.includes(setupCode)) {
            return callback(null, setupCode);
        }
        generateSetupCode(callback);
    });
}
exports.generateSetupCode = generateSetupCode;
function generateSetupCodeSync() {
    var setupCode;
    do {
        setupCode = toString(crypto_1.default.randomBytes(8));
    } while (invalid.includes(setupCode));
    return setupCode;
}
exports.generateSetupCodeSync = generateSetupCodeSync;
//# sourceMappingURL=setupcode.js.map